// AutoEdit.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "AutoEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutoEdit

CAutoEdit::CAutoEdit()
{
    // set some defaults
    m_validateProc = NULL;
    //m_nExitChar = _T('.');
	m_nExitChar = _T(13);
    m_nValidChar = NULL;
    m_nMaxChar = -1;
    m_sDefault.Empty();
    // create the little window for the error messages
    m_pInfoWnd = new CInfoWnd();
}

CAutoEdit::~CAutoEdit()
{
    // free all attached resources
    if (m_nValidChar != NULL) delete [] m_nValidChar;
    delete m_pInfoWnd;
}


BEGIN_MESSAGE_MAP(CAutoEdit, CEdit)
	//{{AFX_MSG_MAP(CAutoEdit)
	ON_WM_CHAR()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CAutoEdit 

void CAutoEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    // filter each character and see that it fits the allowed characters,
    CString s;
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
    if (nChar == m_nExitChar) {
        // if the exit character is pressed, translate it to a TAB
        keybd_event(VK_TAB,0,0,0); // send it 
        return;
    }
m_pInfoWnd->Hide(); 
    if ((m_nValidChar == NULL) || ((m_nValidChar != NULL)                    // do I have to check if the char is valid ?
    &&  (_tcschr(m_nValidChar,nChar) != NULL))) 
	{  // is it a 'valid' character ?
       
        CEdit::OnChar(nChar, nRepCnt, nFlags); // give it to the base class to handle

        // if the max Char flag is set, check the length and exit if field full
        if ((m_nMaxChar != -1)&&   (LineLength() >= m_nMaxChar)) 
		{
            GetWindowText(s); // if the maximum number of characters is reached, simulate a TAB
            keybd_event(VK_TAB,0,0,0); // Sent a TAB !
            return;
        }
    }
    else {
        // if it is a non displayable character, process it anyway (e.g. CTRL+C etc.)
        if (!_istprint(nChar)) {
           CEdit::OnChar(nChar, nRepCnt, nFlags); // let the base class handle it
        }
        else {
            // beep !
            ::MessageBeep(-1); // tell the user that this key is not allowed
        }
    }
}


void CAutoEdit::OnKillFocus(CWnd* pNewWnd) 
{
    CEdit::OnKillFocus(pNewWnd); // ALWAYS call this !
    CString s;
    CWnd* pWnd = GetParent();

    // check if the cancel button is being pressed, this must be treated differently
    // since the user must be allowed to cancel in case of an error

    if (pWnd != pNewWnd) 
	{ // not the cancel button
       if (m_validateProc != NULL) { // a validation procedure has been defined
          GetWindowText(s);
          CString strError;
          strError = m_validateProc->validate(s); // validate the field and return the error message and the formatted contents
          SetWindowText(s); // display the reformatted contents
          if (!strError.IsEmpty()) { // keep it here if not valid
              SetFocus(); // stay in this field
              SetSel(0,-1); // select the contents, for easier correction
              m_pInfoWnd->Show(this,strError); // show the error message in a little window
          }
          else {
              m_pInfoWnd->Hide(); // field is correct, get rid of the litte error message window
          }
       }
    }  
}

void CAutoEdit::SetText(const CString *str)
{
    if (str == NULL) {
        SetWindowText(m_sDefault);
    }
    else {
        SetWindowText((LPCSTR) str);
    }
}

void CAutoEdit::PreSubclassWindow() 
{
	CEdit::PreSubclassWindow();
    m_pInfoWnd->Create(GetParent()); // have to create here, since it is too early in the constructor
                                     // attach the window to the parent (the dialog)   
}
